"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.readData = void 0;

var _papaparse = _interopRequireDefault(require("papaparse"));

var _fsp = _interopRequireDefault(require("./utils/fsp"));

var _path = _interopRequireDefault(require("path"));

var _lodash = _interopRequireDefault(require("lodash"));

var _logger = require("./utils/logger");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var readData =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(projectRoot, config) {
    var data, deckKey;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            data = {};
            _context.t0 = regeneratorRuntime.keys(config);

          case 2:
            if ((_context.t1 = _context.t0()).done) {
              _context.next = 9;
              break;
            }

            deckKey = _context.t1.value;
            _context.next = 6;
            return parseCsv(projectRoot, config[deckKey], deckKey);

          case 6:
            data[deckKey] = _context.sent;
            _context.next = 2;
            break;

          case 9:
            return _context.abrupt("return", data);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function readData(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.readData = readData;

var parseCsv =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(projectRoot, deckConfig, deckKey) {
    var dataFile, csvFile, csv, csvResult, data;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            dataFile = deckConfig.data;
            csvFile = _path.default.join(projectRoot, "data", dataFile);
            (0, _logger.verboseLog)("...looking for CSV file for deck ".concat(deckKey, " in ").concat(csvFile));
            _context2.next = 5;
            return _fsp.default.readFile(csvFile, "utf8");

          case 5:
            csv = _context2.sent;
            csvResult = _papaparse.default.parse(csv, {
              header: true
            }); // TODO: Error checking here

            data = csvResult.data;
            return _context2.abrupt("return", explode(deckConfig, data));

          case 9:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function parseCsv(_x3, _x4, _x5) {
    return _ref2.apply(this, arguments);
  };
}();

var explode = function explode(config, data) {
  if (!config.explode) {
    return data;
  }

  return _lodash.default.flatMap(data, function (row) {
    var explosionCount = row[config.explode] || 1;
    return Array.from({
      length: explosionCount
    }).map(function () {
      return _lodash.default.clone(row);
    });
  });
};